/*
   Keyboard functions
   --------------------------------------------------------------------
   Linberto

   Copyright (C) 1999-2001 Diego Javier Grigna <diego@grigna.com>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

int lin_scancode;

char keyjoy[ 37] = {
' ',
'1', '2', '3', '4', '5', '6', '7', '8', '9', '0', 
'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 
'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
'U', 'V', 'W', 'X', 'Y', 'Z', 
};

char keyttbl[ 128] = {
' ', ' ', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', ' ', ' ', ' ',
' ', 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', ' ', ' ', ' ', ' ',
'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ' ', ' ', ' ', ' ', ' ', 'Z',
'X', 'C', 'V', 'B', 'N', 'M', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '7', '8', '9', ' ',
'4', '5', '6', ' ', '1', '2', '3', '0', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
}; 

void key_handler( int scancode, int press)
{
 lin_scancode = LIN_KEY_NONE;

 if( press == KEY_EVENTRELEASE)
     return;

 lin_scancode = scancode;

 if( scancode > 127)
     lin_scancode = LIN_KEY_NONE;

 keyboard_clearstate();

 switch( lin_scancode) {
         case SCANCODE_F1 : /* Do a screen shot */
                            screen_shot();
                            lin_scancode = LIN_KEY_NONE;
                            break;
         case SCANCODE_F10: /* Set normal brightness */
                            bright = 0;
                            palette_set_brightness();
                            lin_scancode = LIN_KEY_NONE;
                            break;
         case SCANCODE_F11: /* Increase brightness */
                            bright++;
                            palette_set_brightness();
                            lin_scancode = LIN_KEY_NONE;
                            break;
         case SCANCODE_F12: /* Decreases brightness */
                            bright--;
                            palette_set_brightness();
                            lin_scancode = LIN_KEY_NONE;
                            break;
 } /* end switch */

}

void key_wait_for_enter( void)
{
 while( 1) {
       if( keyboard_update() == 0 && joy_button_enter() == 0)
           continue;

       switch( lin_scancode) {
               case SCANCODE_ENTER:
               case SCANCODE_KEYPADENTER: return;
       }
 } /* end while */
}

int key_find_char( char c, int sum)
{
 int i = 0;

 while( keyjoy[ i] != c && i <= 36) i++;

 if( i >= 36)
     i = 36;

 i += sum;

 if( i < 0)
     i = 0;

 if( i >= 36)
     i = 36;

 return keyjoy[ i];
}


